#include "std_precomp.h"
#include "ifl_wx.h" //for the bitmap printing function

const int PERSP_MATRIX_8x6 = 0;
const int PERSP_MATRIX_4x3 = 1;
const wxString PERSP_CHOICES[] = { "8x6", "4x3" };

void TestGLCanvas::InitGL()
{

    /* set viewing projection */
	setPersp(0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
}

void TestGLCanvas::setPersp(const int p) {
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	switch(p) {
	case PERSP_MATRIX_8x6:
		glOrtho(-4.,4.,-3.,3.,-1.,2.);
		break;

	case PERSP_MATRIX_4x3:
		glOrtho(-2.,2.,-1.5,1.5,-1.,2.);
		break;

	default:
		glOrtho(-2.,2.,-1.5,1.5,-1.,2.);
	}

	glMatrixMode(GL_MODELVIEW);
}

void TestGLCanvas::gl_draw() {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	p_gen->flat_draw();
}



void TestGLCanvas::gl_print_screen(const char * fname) {
	GLint	viewport[4];
	glGetIntegerv(GL_VIEWPORT, viewport);
	unsigned char * data = new unsigned char[viewport[2]*viewport[3]*3];
	glReadPixels(viewport[0],viewport[1],viewport[2],viewport[3], 
		GL_RGB ,    GL_UNSIGNED_BYTE,	data );

	ifl_make_bitmap(fname, data, iflSize(viewport[2],viewport[3],3));

	delete [] data;
}