#include "std_precomp.h"

/* -----------------------------------------------------------------------
  Main Window
-------------------------------------------------------------------------*/

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    
	EVT_MENU(wxID_EXIT, MyFrame::OnExit)
	EVT_MENU(ID_PRINT_SCREEN, MyFrame::OnPrint)

	EVT_MENU(ID_CHANGE_PERSP, MyFrame::ChangePersp)
	EVT_MENU(ID_TWEAK_BITMAP, MyFrame::TweakBitmap)
	EVT_MENU(ID_TWEAK_PARAMS, MyFrame::TweakParams)
	EVT_MENU(ID_TWEAK_COLOR_MAP, MyFrame::ChangeColorMap)
	EVT_MENU(ID_EXPORT_SPE, MyFrame::SPE_Export)
	EVT_MENU(ID_IMPORT_SPE, MyFrame::SPE_Import)


END_EVENT_TABLE()

// My frame constructor
MyFrame::MyFrame(wxFrame *frame, const wxString& title, const wxPoint& pos,
                 const wxSize& size, long style)
         : wxFrame(frame, -1, title, pos, size, style)
{
    m_canvas = NULL;
}

// Intercept menu commands
void MyFrame::OnExit(wxCommandEvent& event)
{
    Destroy();
}

void MyFrame::OnPrint(wxCommandEvent& event) {    
	wxFileDialog dialog(this,
                        _T("Save screen to what file?"),
                        _T(""),
                        _T("screenshot.bmp"),
                        _T("Bitmap files (*.bmp)|*.bmp"),
                        wxSAVE);

    if (dialog.ShowModal() == wxID_OK)
			m_canvas->gl_print_screen(dialog.GetPath());

}

/*------------------------------------------------------------------
  Application object ( equivalent to main() )
------------------------------------------------------------------ */

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit(void)
{
  wxLog::SetTraceMask(wxTraceMessages);

  // Create the main frame window
  MyFrame *frame = new MyFrame(NULL, "Sven's Particle Swarm Designer", wxPoint(50, 50),
                               wxSize(640, 480));
  // Give it an icon
#ifdef wx_msw
  frame->SetIcon(wxIcon("mondrian"));
#endif

  // Make a menubar
  wxMenuBar *menuBar = new wxMenuBar;

  wxMenu *fileMenu = new wxMenu;
  fileMenu->Append(ID_PRINT_SCREEN, "&Print Screen");
  fileMenu->Append(wxID_EXIT, "&Quit");
  menuBar->Append(fileMenu, "&File");

  menuBar->Append(StandardEmitterMenu(), "&Tweak");

  frame->SetMenuBar(menuBar);

  frame->m_canvas = new TestGLCanvas(frame, -1, wxDefaultPosition, wxDefaultSize);

  // Show the frame
  frame->Show(TRUE);

  return TRUE;
}
